﻿using System.ServiceModel;
using System.Windows.Input;
using Vertrag;
using HilfeTools;
using System.Threading;
using System.Net;
using System.Windows;
using System;
using System.Diagnostics;
using System.IO;


namespace Client.Viewmodel {
   public partial class MainModel : Chilfe {
      private IvertragAsynchron objProxy;

      public string _stringContent = "";
      public string StringContent {
         get { return _stringContent; }
         set { _stringContent = value; NotifyPropertyChanged("StringContent"); }
      }

      public string ipAddress { get; set; }
      public string portNumber { get; set; }

      private Cbefehl _GetDataCommand;
      public ICommand GetDataCommand {
         get { return(_GetDataCommand?? (_GetDataCommand=new Cbefehl(OnClick))); }
      }

      private Cbefehl _Speichern;
      public ICommand Speichern {
         get { return(_Speichern??(_Speichern= new Cbefehl(OnSpeichern))); }
      }

      private Cbefehl _Laden;
      public ICommand Laden {
         get { return (_Laden??(_Laden= new Cbefehl(OnLaden))); }
      }


      public void OnSpeichern() {
         Microsoft.Win32.SaveFileDialog dialog = new Microsoft.Win32.SaveFileDialog();
         dialog.Filter = "Txt-Files(*.txt)|*.txt";
         Nullable<bool> result = dialog.ShowDialog();
         if (result == true) {
            File.WriteAllText(dialog.FileName, ipAddress);
         }
         Nullable<bool> result2 = dialog.ShowDialog();
         if (result2 == true) {
            File.WriteAllText(dialog.FileName, portNumber);
         }
      }

      public void OnLaden() {
         Microsoft.Win32.OpenFileDialog dialogo = new Microsoft.Win32.OpenFileDialog();
         dialogo.Filter = "Txt-Files(*.txt)|*.txt";
         Nullable<bool> result = dialogo.ShowDialog();
         if (result == true) {
            ipAddress = File.ReadAllText(dialogo.FileName);
         }
         Nullable<bool> result2 = dialogo.ShowDialog();
         if (result2 == true) {
            portNumber = File.ReadAllText(dialogo.FileName);
         }
      }

      public void OnClick() {
         try {
            string rmAddres = null;
            rmAddres = "net.tcp://" + ipAddress + ":" + portNumber + "/IvertragAsynchron";

            NetTcpBinding nettcpbinding = new NetTcpBinding(SecurityMode.None); // new NetTcpBinding(hier MUSS was stehen!! sonst tuts ned) 
            ChannelFactory<IvertragAsynchron> chFactory = new ChannelFactory<IvertragAsynchron>(nettcpbinding);
            nettcpbinding.MaxReceivedMessageSize = 10485760; // 10485760 entspricht 10 MB

            TimeSpan mSpan = default(TimeSpan);
            mSpan = new TimeSpan(1200000000); // entspricht 2 Minuten (1 Millisekunde = 10.000 Ticks) -> 2min = 120.000ms = 1.200.000.000Ticks
            nettcpbinding.SendTimeout = mSpan;

            EndpointAddress epAddress = new EndpointAddress(rmAddres);
            objProxy = chFactory.CreateChannel(epAddress);

            this.StringContent = "Anfrage läuft...";
            if (objProxy.Ping()) {
               objProxy.BeginDoIt(asyncResult => {
                  this.StringContent = objProxy.EndDoIt(asyncResult).Content;
               }, null);
            }
         }
         catch (Exception ex) {
            MessageBox.Show("Leider ist ein Fehler aufgetreten:\r\n" + ex.Message);
         }
      }
   }
}
